#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void open();

	void zchannels();

private:
	float *input1_buffer; // pointer to circular buffer of samples
	float *input2_buffer;
	float *input3_buffer;
	float *input4_buffer;
	float *input5_buffer;
	float *input6_buffer;
	float *input7_buffer;
	float *input8_buffer;
	float *input9_buffer;
	float *input10_buffer;
	float *input11_buffer;
	float *input12_buffer;
	float *input13_buffer;
	float *input14_buffer;
	float *input15_buffer;
	float *input16_buffer;
	float *output1_buffer;
	float *output2_buffer;
	float samplerate;
	float b0[8192];
	float b1[8192];
	float b2[8192];
	float b3[8192];
	float b4[8192];
	float b5[8192];
	float b6[8192];
	float b7[8192];

	float l0, l1, l2, l3;
	float d1, d2, d3;
	float c1, c2, c3, c4, c5;	// check last input

	int i1, i2, i3, i4, i5, i6, i7;
	int p1, p2, p3, p4, p5;
	int q1, q2, q3;
	int r1, r2, r3, r4, r5, r6, r7;
	float r, rr, rt;

	float o0, o1, o2, o3, o4, o5, o6, o7;
	float f0, f3, f5, f7;
	float v0, v1, v2;
/*
b0>b1>b2>		b0>b1>
b3<b4<b5<		b2<b3<
     b6 v^ b7		   b4 v^ b5
     b8<><>b9		   b6<><>b7
l1*l2*l3		l1*l2
	l4		     l3
      l5  l6		   l4  l5
*/
	int static_count;
};
#endif